import <kkk.ash>
record _skills {
   skill _skill;
   boolean _perm;
   boolean _hc_perm;
   boolean _usable;
};

_skills [int] skills;

string build_line(_skills s) {
   buffer temp;
   temp.append("<tr");
   if (!s._usable)
      temp.append(" style='color: #999; text-decoration: line-through;'");
   temp.append(">");
   temp.append("<td><a onClick='javascript:poop(\"desc_skill.php?whichskill=" + to_int(s._skill) + "&self=true\",\"skill\", 350, 300)'>" + to_string(s._skill) + "</a></td>");
   if (s._hc_perm)
      temp.append("<td><b>HP</b></td>");
    else if (s._perm) temp.append("<td>P</td>");
    else temp.append("<td>-</td>");
   temp.append("</tr>");
   return to_string(temp);
}

string build_title_line(string t) {
   return ("<tr><td colspan=2 align='center'><b>" + t + "</b></td></tr>");
}

string build_sub_title_line(string t) {
   return ("<tr><td colspan=2 align='center'><i>" + t + "</i></td></tr>");
}

string build_section(int min, int max, string t, boolean sub) {
   string s;
   boolean title = (t == "");
   foreach i in skills {
      if (i >= min && i <= max) {
         if (!title) {
               if (!sub) {
                  s = (s + build_title_line(t));
               }
               else {
                  s = (s + build_sub_title_line(t));
               }
               title = true;
            }
         s = (s + build_line(skills[i]));
      } else if (i > max) break;
   }
   return s;
}

string build_section(int min, int max, string t) {
   return build_section(min, max, t, false);
}

void parse_skill_block(string sub, boolean usable) {
  // Append a space at the end so our substring won't choke on
  // the last skill in the table.
   sub = sub + " ";
   while (true) {
      if (!contains_text(sub, "<br>")) break;
      int curr = index_of(sub, "<br>");
      string current_substring = substring(sub, 0, curr);

      sub = substring(sub, curr + 4);

      int skill_id;
      if (current_substring.contains_text("whichskill"))
      {
         skill_id = to_int(substring(current_substring, index_of(current_substring, "whichskill=") + 11, index_of(current_substring, "&")));   
      }
      else
      {
         skill_id = to_int(substring(current_substring, index_of(current_substring, "(") + 1, index_of(current_substring, ")")));
      }

      skills[skill_id]._skill = to_skill(substring(current_substring, index_of(current_substring, "'>") + 2, index_of(current_substring, "</a>")));
      skills[skill_id]._hc_perm = contains_text(current_substring, "(<b>HP</b>)");
      skills[skill_id]._perm = (contains_text(current_substring, "(<b>HP</b>)") || contains_text(current_substring, "(P)"));
      skills[skill_id]._usable = usable;
   }
}

buffer skill_list(string source) {
	results.append(source);

	int start_index = index_of(source, "<p>Skills:</b><br><font size=1>(click the skill name for a description)</font><br>");

	// If this returns -1 it means the charsheet didn't load correctly (typically from being in a combat).
	if (start_index < 0)
		return results;

	start_index = index_of(source, "<a", start_index);
	string sub = substring(source, start_index);

	sub = substring(sub, 0, index_of(sub, "</td>"));
	string save = sub;

	// Build the skills for the main block.
	parse_skill_block(sub, true);

	// Check for permanent skills you can't use right now, we mark these
	// with a strikethrough and gray to tell you that they are unusable.
	int start2_index = index_of(source, "<tr><td height=1 bgcolor=black></td></tr><tr><td><a id='permlink' class=tiny href='javascript:toggle(\"permskills\");'>[show permanent skills you can't use right now]");

	if (start2_index > 0)
	{
		// Get the section from the character sheet. We add a pad to 
		// jump over the first anchor tag for the javascript.
		int start2a_index = index_of(source, "<a", start2_index + 50);
		string sub2 = substring(source, start2a_index);
		sub2 = substring(sub2, 0, index_of(sub2, "</td>"));

		// Parse it and add those skills to the master list.
		parse_skill_block(sub2, false);

		// Remove the block entirely from the output.
		int end2_index = index_of(source, "</tr>", start2_index + 50) + 5;
		results.replace_string(substring(source, start2_index, end2_index), "");
	}

	// Rebuild the entire section as a table.
	string rep= build_section(0000,0009, "Class-Independent");
   rep = rep + build_section(0015,0020, "");
   rep = rep + build_section(0044,0045, "");
   rep = rep + build_section(0049,0999, "");

   rep = rep + build_section(0010,0014, "Regnaissance Gnome", true);

   rep = rep + build_section(0021,0027, "Bad Moon", true);

   rep = rep + build_section(0028,0037, "Hobopolis", true);
   rep = rep + build_section(0042,0043, "");
   rep = rep + build_section(0038,0041, "");

   rep = rep + build_section(0046,0048, "Slime Tube", true);

	rep = rep + build_section(1000,1999, "Seal Clubber");
	rep = rep + build_section(2000,2999, "Turtle Tamer");
	rep = rep + build_section(3000,3999, "Pastamancer");
	rep = rep + build_section(4000,4999, "Sauceror");
	rep = rep + build_section(5000,5999, "Disco Bandit");
	rep = rep + build_section(6000,6019, "Accordion Thief");
   rep = rep + build_section(6025,6999, "");
   rep = rep + build_section(6020,6024, "Hobopolis", true);

	// I don't think the following ever appear on the charsheet.
	rep = rep + build_section(7000,7999, "Conditional");
	rep = rep + build_section(8000,8999, "Mystical Bookshelf");

	results.replace_string("<tr><td>" + save + "</td></tr>", rep);
	results.replace_string("<table><tr><td height=1 bgcolor=black></td></tr><tr>", "<table><tr><td height=1 bgcolor=black colspan=2></td></tr><tr>");
	results.replace_string("<tr><td height=1 bgcolor=black></td></tr><tr><td>(P) = Permanent skill</td></tr><tr><td>(<b>HP</b>) = Hardcore Permanent skill</td></tr><tr><td height=1 bgcolor=black></td></tr></table>", "<tr><td height=1 bgcolor=black colspan=2></td></tr><tr><td>(P) = Permanent skill</td></tr><tr><td>(<b>HP</b>) = Hardcore Permanent skill</td></tr><tr><td height=1 bgcolor=black colspan=2></td></tr></table>");
	
	// add a link to your public charsheet
	results.replace_string("<center><table><tr><td><center><img src", "<center><table><tr><td><center><a href=\"showplayer.php?who="+my_id()+"\" title=\"View public charsheet\"><img src");
	results.replace_string("An Adventurer is You!\">","An Adventurer is You!\"></a>");
   kkkify();
   return results;
}

void main() {
	skill_list(visit_url()).write();
}
